package com.gemho.netty.util;


import io.netty.channel.Channel;

import java.util.LinkedHashMap;
import java.util.Map;
import java.util.concurrent.locks.ReentrantLock;

public class MapUtils {

    private static ReentrantLock lock = new ReentrantLock();

    private static Map<String, Channel> map = new LinkedHashMap<>();

    public static void addMap(String key, Channel channel) {
        lock.lock();
        map.put(key, channel);
        lock.unlock();
    }

    public static void removeMap(String key){
        lock.lock();
        map.remove(key);
        lock.unlock();
    }

    public static Channel getMapChannel(String key) {
        try{
            lock.lock();
            return map.get(key);
        }finally {
            lock.unlock();
        }
    }

}
