package com.gemho.netty.util;

import io.netty.buffer.ByteBuf;

import java.net.SocketAddress;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.concurrent.locks.ReentrantLock;

public class ParamUtil {

    private static ReentrantLock lock = new ReentrantLock();

    private static Map<SocketAddress, Map<Integer, ByteBuf>> PARAM_MAP = new LinkedHashMap<>();

    public static void addMap(SocketAddress key,  Map<Integer, ByteBuf> map) {
        lock.lock();
        PARAM_MAP.put(key, map);
        lock.unlock();
    }

    public static void updateMap(SocketAddress key, Map<Integer, ByteBuf> map) {
        lock.lock();
        PARAM_MAP.replace(key, map);
        lock.unlock();
    }

    public static void removeMap(SocketAddress key) {
        lock.lock();
        PARAM_MAP.remove(key);
        lock.unlock();
    }

    public static Map<Integer, ByteBuf> findMap(SocketAddress key) {
        lock.lock();
        try{
            return PARAM_MAP.get(key);
        }catch(Exception e) {
            e.printStackTrace();
            return null;
        } finally {
            lock.unlock();
        }
    }

}
